// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GDKMM_PIXMAP_H
#define _GDKMM_PIXMAP_H

#include <glibmm.h>

/* $Id: pixmap.hg,v 1.17 2002/04/02 13:23:10 daniel Exp $ */

/* pixmap.h
 *
 * Copyright (C) 1998-1999 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gdkmm/drawable.h>
//#include <gdkmm/window.h>
#include <gdkmm/color.h>
#include <gdkmm/colormap.h>
#include <gdkmm/types.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
//typedef struct _GdkPixmap GdkPixmap;
//typedef struct _GdkPixmapClass GdkPixmapClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gdk
{ class Pixmap_Class; } // namespace Gdk
namespace Gdk
{

class Window;


class Pixmap : public Gdk::Drawable
{
  // GdkPixmap is a typedef to GdkDrawable, but it's actually a GdkPixmapObject.
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Pixmap          CppObjectType;
  typedef Pixmap_Class    CppClassType;
  typedef GdkPixmap           BaseObjectType;
  typedef GdkPixmapObjectClass      BaseClassType;

private:
  friend class CppClassType;
  static CppClassType pixmap_class_;

  Pixmap(const Pixmap&);
  Pixmap& operator=(const Pixmap&); // not implemented

protected:
  explicit Pixmap(GdkPixmap* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Pixmap();

  static Glib::RefPtr<Pixmap> wrap_specific_type(GdkPixmap* gobject, bool take_copy = false); //Re-uses the existing wrapper, if it exists.

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GdkPixmap* gobj()             { return (GdkPixmap*)(gobject_); }
  const GdkPixmap* gobj() const { return (GdkPixmap*)(gobject_); }

  GdkPixmap* gobj_copy();


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

  
protected:

  Pixmap();

  Pixmap(const Glib::RefPtr<Window>& window, int width, int height, int depth = -1);

  /// Initialize a Pixmap from data.
  Pixmap(const Glib::RefPtr<Window>& window, const char* data, int width, int height, int	depth,
				 const Color& fg, const Color& bg);
  

public:

  
  static Glib::RefPtr<Pixmap> create();

  
  static Glib::RefPtr<Pixmap> create(const Glib::RefPtr<Window>& window, int width, int height, int depth = -1);

  
  static Glib::RefPtr<Pixmap> create(const Glib::RefPtr<Window>& window, const char* data, int width, int height, int	depth, const Color& fg, const Color& bg);


  static Glib::RefPtr<Pixmap> create_from_data(
			const Glib::RefPtr<const Drawable>& drawable,
			const char *data,
			int        width,
			int        height,
			int        depth,
			const Color& fg,
			const Color& bg);

  //: Create a Pixmap from a xpm file.
  static Glib::RefPtr<Pixmap> create_from_xpm(
		       const Glib::RefPtr<const Drawable>& drawable,
		       const Color& transparent_color,
		       const Glib::ustring& filename);

  //: Create a Pixmap from a xpm file.
  static Glib::RefPtr<Pixmap> create_from_xpm(
		       const Glib::RefPtr<const Drawable>& drawable,
		       Glib::RefPtr<Bitmap>& mask,
		       const Color& transparent_color,
		       const Glib::ustring& filename);

  //: Create a Pixmap from a xpm file with colormap.
  static Glib::RefPtr<Pixmap> create_from_xpm(
				const Glib::RefPtr<const Drawable>& drawable,
				const Glib::RefPtr<Colormap>& colormap,
				Glib::RefPtr<Bitmap>& bitmap,
				const Color& transparent_color,
				const Glib::ustring& filename);

  static Glib::RefPtr<Pixmap> create_from_xpm(const Glib::RefPtr<const Drawable>& drawable,
			 Glib::RefPtr<Bitmap>& bitmap,
			 const Color& transparent_color,
			 const char * const *data);

  static Glib::RefPtr<Pixmap> create_from_xpm(const Glib::RefPtr<const Drawable>& drawable,
				   const Glib::RefPtr<Colormap>& colormap,
				   Glib::RefPtr<Bitmap>& mask,
				   const Color& transparent_color,
				   const char * const *data);

  static Glib::RefPtr<Pixmap> create_from_xpm(const Glib::RefPtr<Colormap>& colormap,
				   Glib::RefPtr<Bitmap>& mask,
				   const Color& transparent_color,
				   const char * const *data);

  static Glib::RefPtr<Pixmap> create_from_xpm(const Glib::RefPtr<Colormap>& colormap,
				   Glib::RefPtr<Bitmap>& mask,
				   const char * const *data);


  static void warn_about_xpm_file_problem(const Glib::ustring& filename);

  static const char* const* defaultPixmap;


};

} /* namespace Gdk */


#endif /* _GDKMM_PIXMAP_H */

