
#include <gtkmm/entry.h>
#include <gtkmm/private/entry_p.h>

// -*- c++ -*-
/* $Id: entry.ccg,v 1.7 2001/10/25 11:17:19 murrayc Exp $ */

/* 
 *
 * Copyright 1998-1999 The Gtk-- Development Team
 * Copyright 2001      Free Software Foundation
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk/gtkentry.h>


namespace
{


void Entry_signal_populate_popup_callback(GtkEntry*, GtkMenu* p0,void* data)
{
  using namespace Gtk;
  typedef SigC::Slot1<void,Menu*> SlotType;

  try
  {
    SigC::SlotNode *const slot = Glib::SignalProxyNormal::data_to_slot(data);
    (*(SlotType::Proxy)(slot->proxy_))
        (Glib::wrap(p0)
, slot);
  }
  catch(...)
  {
    Glib::exception_handlers_invoke();
  }
}

const Glib::SignalProxyInfo Entry_signal_populate_popup_info =
{
  "populate_popup",
  (GCallback) &Entry_signal_populate_popup_callback,
  (GCallback) &Entry_signal_populate_popup_callback
};


const Glib::SignalProxyInfo Entry_signal_activate_info =
{
  "activate",
  (GCallback) &Glib::SignalProxyNormal::slot0_void_callback,
  (GCallback) &Glib::SignalProxyNormal::slot0_void_callback
};


void Entry_signal_move_cursor_callback(GtkEntry*, GtkMovementStep p0,gint p1,gboolean p2,void* data)
{
  using namespace Gtk;
  typedef SigC::Slot3<void,MovementStep,int,bool> SlotType;

  try
  {
    SigC::SlotNode *const slot = Glib::SignalProxyNormal::data_to_slot(data);
    (*(SlotType::Proxy)(slot->proxy_))
        (((MovementStep)(p0))
,p1
,p2
, slot);
  }
  catch(...)
  {
    Glib::exception_handlers_invoke();
  }
}

const Glib::SignalProxyInfo Entry_signal_move_cursor_info =
{
  "move_cursor",
  (GCallback) &Entry_signal_move_cursor_callback,
  (GCallback) &Entry_signal_move_cursor_callback
};


void Entry_signal_insert_at_cursor_callback(GtkEntry*, const gchar* p0,void* data)
{
  using namespace Gtk;
  typedef SigC::Slot1<void,const Glib::ustring&> SlotType;

  try
  {
    SigC::SlotNode *const slot = Glib::SignalProxyNormal::data_to_slot(data);
    (*(SlotType::Proxy)(slot->proxy_))
        (Glib::convert_const_gchar_ptr_to_ustring(p0)
, slot);
  }
  catch(...)
  {
    Glib::exception_handlers_invoke();
  }
}

const Glib::SignalProxyInfo Entry_signal_insert_at_cursor_info =
{
  "insert_at_cursor",
  (GCallback) &Entry_signal_insert_at_cursor_callback,
  (GCallback) &Entry_signal_insert_at_cursor_callback
};


void Entry_signal_delete_from_cursor_callback(GtkEntry*, GtkDeleteType p0,gint p1,void* data)
{
  using namespace Gtk;
  typedef SigC::Slot2<void,DeleteType,int> SlotType;

  try
  {
    SigC::SlotNode *const slot = Glib::SignalProxyNormal::data_to_slot(data);
    (*(SlotType::Proxy)(slot->proxy_))
        (((DeleteType)(p0))
,p1
, slot);
  }
  catch(...)
  {
    Glib::exception_handlers_invoke();
  }
}

const Glib::SignalProxyInfo Entry_signal_delete_from_cursor_info =
{
  "delete_from_cursor",
  (GCallback) &Entry_signal_delete_from_cursor_callback,
  (GCallback) &Entry_signal_delete_from_cursor_callback
};


const Glib::SignalProxyInfo Entry_signal_cut_clipboard_info =
{
  "cut_clipboard",
  (GCallback) &Glib::SignalProxyNormal::slot0_void_callback,
  (GCallback) &Glib::SignalProxyNormal::slot0_void_callback
};


const Glib::SignalProxyInfo Entry_signal_copy_clipboard_info =
{
  "copy_clipboard",
  (GCallback) &Glib::SignalProxyNormal::slot0_void_callback,
  (GCallback) &Glib::SignalProxyNormal::slot0_void_callback
};


const Glib::SignalProxyInfo Entry_signal_paste_clipboard_info =
{
  "paste_clipboard",
  (GCallback) &Glib::SignalProxyNormal::slot0_void_callback,
  (GCallback) &Glib::SignalProxyNormal::slot0_void_callback
};


const Glib::SignalProxyInfo Entry_signal_toggle_overwrite_info =
{
  "toggle_overwrite",
  (GCallback) &Glib::SignalProxyNormal::slot0_void_callback,
  (GCallback) &Glib::SignalProxyNormal::slot0_void_callback
};

} // anonymous namespace


namespace Glib
{

Gtk::Entry* wrap(GtkEntry* object, bool take_copy /* = false */)
{
  return dynamic_cast<Gtk::Entry *> (Glib::wrap_auto ((GObject*)(object), take_copy));
}

} /* namespace Glib */

namespace Gtk
{


/* The *_Class implementation: */

GType Entry_Class::get_type()
  {
    if (!gtype_) //Create the GType if necessary.
      {
        //Make sure that the parent type has been created:
        CppClassParent::CppObjectType::get_type();

        //Create a derived C type.
        //These init funcs will, in turn, call the init functions in the base C type.
        GTypeInfo info =
          {
            sizeof(BaseClassType), /* class_size */
            0, /* base_init */
            0, /* base_finalize */
            (GClassInitFunc) &class_init_function, /* class_init */
            0, /* class_finalize */
            0, /* class_data */
            sizeof(BaseObjectType), /* instance_size */
            0, /* n_preallocs */
            0, /* instance_init */
	    0 /* value_table */
          };

        gtype_ = g_type_register_static(gtk_entry_get_type(), "gtkmm__Entry", &info, GTypeFlags(0));

  //Add derived versions of interfaces, if the C type implements any interfaces:
  Editable::add_interface(get_type());
  CellEditable::add_interface(get_type());
      }
    return gtype_;
  }
void Entry_Class::class_init_function(BaseClassType* klass)
{
  CppClassParent::class_init_function((CppClassParent::BaseClassType*) klass);
  klass->populate_popup = &populate_popup_callback;
  klass->activate = &activate_callback;
  klass->move_cursor = &move_cursor_callback;
  klass->insert_at_cursor = &insert_at_cursor_callback;
  klass->delete_from_cursor = &delete_from_cursor_callback;
  klass->cut_clipboard = &cut_clipboard_callback;
  klass->copy_clipboard = &copy_clipboard_callback;
  klass->paste_clipboard = &paste_clipboard_callback;
  klass->toggle_overwrite = &toggle_overwrite_callback;
}


void Entry_Class::populate_popup_callback(GtkEntry* self, GtkMenu* p0)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  if(obj)
  {
    try
    {
      obj->on_populate_popup(Glib::wrap(p0)
);
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class.
);
    g_assert(base != 0);

    if(base->populate_popup)
      (*base->populate_popup)(self, p0);
  }
}

void Entry_Class::activate_callback(GtkEntry* self)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  if(obj)
  {
    try
    {
      obj->on_activate();
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class.
);
    g_assert(base != 0);

    if(base->activate)
      (*base->activate)(self);
  }
}

void Entry_Class::move_cursor_callback(GtkEntry* self, GtkMovementStep p0, gint p1, gboolean p2)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  if(obj)
  {
    try
    {
      obj->on_move_cursor(((MovementStep)(p0))
, p1
, p2
);
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class.
);
    g_assert(base != 0);

    if(base->move_cursor)
      (*base->move_cursor)(self, p0, p1, p2);
  }
}

void Entry_Class::insert_at_cursor_callback(GtkEntry* self, const gchar* p0)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  if(obj)
  {
    try
    {
      obj->on_insert_at_cursor(Glib::convert_const_gchar_ptr_to_ustring(p0)
);
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class.
);
    g_assert(base != 0);

    if(base->insert_at_cursor)
      (*base->insert_at_cursor)(self, p0);
  }
}

void Entry_Class::delete_from_cursor_callback(GtkEntry* self, GtkDeleteType p0, gint p1)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  if(obj)
  {
    try
    {
      obj->on_delete_from_cursor(((DeleteType)(p0))
, p1
);
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class.
);
    g_assert(base != 0);

    if(base->delete_from_cursor)
      (*base->delete_from_cursor)(self, p0, p1);
  }
}

void Entry_Class::cut_clipboard_callback(GtkEntry* self)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  if(obj)
  {
    try
    {
      obj->on_cut_clipboard();
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class.
);
    g_assert(base != 0);

    if(base->cut_clipboard)
      (*base->cut_clipboard)(self);
  }
}

void Entry_Class::copy_clipboard_callback(GtkEntry* self)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  if(obj)
  {
    try
    {
      obj->on_copy_clipboard();
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class.
);
    g_assert(base != 0);

    if(base->copy_clipboard)
      (*base->copy_clipboard)(self);
  }
}

void Entry_Class::paste_clipboard_callback(GtkEntry* self)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  if(obj)
  {
    try
    {
      obj->on_paste_clipboard();
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class.
);
    g_assert(base != 0);

    if(base->paste_clipboard)
      (*base->paste_clipboard)(self);
  }
}

void Entry_Class::toggle_overwrite_callback(GtkEntry* self)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  if(obj)
  {
    try
    {
      obj->on_toggle_overwrite();
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class.
);
    g_assert(base != 0);

    if(base->toggle_overwrite)
      (*base->toggle_overwrite)(self);
  }
}


Glib::ObjectBase* Entry_Class::wrap_new(GObject* o)
{
  return manage(new Entry((GtkEntry*)(o)));
}


/* The implementation: */

Entry::Entry(GtkEntry* castitem)
: Gtk::Widget((GtkWidget*)(castitem))
{}

Entry::~Entry()
{
  destroy_();
}

Entry::CppClassType Entry::entry_class_; //Initialize static member.

GType Entry::get_type()
{
  return entry_class_.get_type();
}

GType Entry::get_base_type()
{
  return gtk_entry_get_type();
}

Entry::Entry()
: Gtk::Widget((GtkWidget*)(g_object_new(get_type(), (char*)0)))
{}

void Entry::set_visibility(bool visible)
{
  gtk_entry_set_visibility(gobj(), static_cast<int>(visible));
}

bool Entry::get_visibility() const
{
  return gtk_entry_get_visibility(const_cast<GtkEntry*>(gobj()));
}

void Entry::set_invisible_char(gunichar ch)
{
  gtk_entry_set_invisible_char(gobj(), ch);
}

gunichar Entry::get_invisible_char() const
{
  return gtk_entry_get_invisible_char(const_cast<GtkEntry*>(gobj()));
}

void Entry::set_has_frame(bool setting)
{
  gtk_entry_set_has_frame(gobj(), static_cast<int>(setting));
}

bool Entry::get_has_frame() const
{
  return gtk_entry_get_has_frame(const_cast<GtkEntry*>(gobj()));
}

void Entry::set_max_length(int max)
{
  gtk_entry_set_max_length(gobj(), max);
}

int Entry::get_max_length() const
{
  return gtk_entry_get_max_length(const_cast<GtkEntry*>(gobj()));
}

void Entry::set_activates_default(bool setting)
{
  gtk_entry_set_activates_default(gobj(), static_cast<int>(setting));
}

gboolean Entry::get_activates_default() const
{
  return gtk_entry_get_activates_default(const_cast<GtkEntry*>(gobj()));
}

void Entry::set_width_chars(int n_chars)
{
  gtk_entry_set_width_chars(gobj(), n_chars);
}

int Entry::get_width_chars() const
{
  return gtk_entry_get_width_chars(const_cast<GtkEntry*>(gobj()));
}

void Entry::set_text(const Glib::ustring & text)
{
  gtk_entry_set_text(gobj(), text.c_str());
}

Glib::ustring Entry::get_text() const
{
  return Glib::convert_const_gchar_ptr_to_ustring(gtk_entry_get_text(const_cast<GtkEntry*>(gobj())));
}

Glib::RefPtr<Pango::Layout> Entry::get_layout()
{
  return Glib::wrap(gtk_entry_get_layout(gobj()));
}

void Entry::get_layout_offsets(int& x, int& y)
{
  gtk_entry_get_layout_offsets(gobj(), &x, &y);
}

guint16 Entry::get_text_length() const
{
  return gobj()->text_length;
}


Glib::SignalProxy1<void,Menu*> Entry::signal_populate_popup()
{
  return Glib::SignalProxy1<void,Menu*>(this, &Entry_signal_populate_popup_info);
}

Glib::SignalProxy0<void> Entry::signal_activate()
{
  return Glib::SignalProxy0<void>(this, &Entry_signal_activate_info);
}

Glib::SignalProxy3<void,MovementStep,int,bool> Entry::signal_move_cursor()
{
  return Glib::SignalProxy3<void,MovementStep,int,bool>(this, &Entry_signal_move_cursor_info);
}

Glib::SignalProxy1<void,const Glib::ustring&> Entry::signal_insert_at_cursor()
{
  return Glib::SignalProxy1<void,const Glib::ustring&>(this, &Entry_signal_insert_at_cursor_info);
}

Glib::SignalProxy2<void,DeleteType,int> Entry::signal_delete_from_cursor()
{
  return Glib::SignalProxy2<void,DeleteType,int>(this, &Entry_signal_delete_from_cursor_info);
}

Glib::SignalProxy0<void> Entry::signal_cut_clipboard()
{
  return Glib::SignalProxy0<void>(this, &Entry_signal_cut_clipboard_info);
}

Glib::SignalProxy0<void> Entry::signal_copy_clipboard()
{
  return Glib::SignalProxy0<void>(this, &Entry_signal_copy_clipboard_info);
}

Glib::SignalProxy0<void> Entry::signal_paste_clipboard()
{
  return Glib::SignalProxy0<void>(this, &Entry_signal_paste_clipboard_info);
}

Glib::SignalProxy0<void> Entry::signal_toggle_overwrite()
{
  return Glib::SignalProxy0<void>(this, &Entry_signal_toggle_overwrite_info);
}


Glib::PropertyProxy_ReadOnly<int> Entry::property_cursor_position()
{
  return Glib::PropertyProxy_ReadOnly<int>(this, "cursor_position");
}

Glib::PropertyProxy_ReadOnly<int> Entry::property_selection_bound()
{
  return Glib::PropertyProxy_ReadOnly<int>(this, "selection_bound");
}

Glib::PropertyProxy<bool> Entry::property_editable()
{
  return Glib::PropertyProxy<bool>(this, "editable");
}

Glib::PropertyProxy<int> Entry::property_max_length()
{
  return Glib::PropertyProxy<int>(this, "max_length");
}

Glib::PropertyProxy<bool> Entry::property_visibility()
{
  return Glib::PropertyProxy<bool>(this, "visibility");
}

Glib::PropertyProxy<bool> Entry::property_has_frame()
{
  return Glib::PropertyProxy<bool>(this, "has_frame");
}

Glib::PropertyProxy<gunichar> Entry::property_invisible_char()
{
  return Glib::PropertyProxy<gunichar>(this, "invisible_char");
}

Glib::PropertyProxy<bool> Entry::property_activates_default()
{
  return Glib::PropertyProxy<bool>(this, "activates_default");
}

Glib::PropertyProxy<int> Entry::property_width_chars()
{
  return Glib::PropertyProxy<int>(this, "width_chars");
}

Glib::PropertyProxy_ReadOnly<int> Entry::property_scroll_offset()
{
  return Glib::PropertyProxy_ReadOnly<int>(this, "scroll_offset");
}

Glib::PropertyProxy<Glib::ustring> Entry::property_text()
{
  return Glib::PropertyProxy<Glib::ustring>(this, "text");
}


void Gtk::Entry::on_populate_popup(Menu* menu)
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class.
);
  g_assert(base != 0);

  if(base->populate_popup)
    (*base->populate_popup)(gobj(),(GtkMenu*)Glib::unwrap(menu));
}

void Gtk::Entry::on_activate()
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class.
);
  g_assert(base != 0);

  if(base->activate)
    (*base->activate)(gobj());
}

void Gtk::Entry::on_move_cursor(MovementStep step, int count, bool extend_selection)
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class.
);
  g_assert(base != 0);

  if(base->move_cursor)
    (*base->move_cursor)(gobj(),((GtkMovementStep)(step)),count,static_cast<int>(extend_selection));
}

void Gtk::Entry::on_insert_at_cursor(const Glib::ustring& str)
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class.
);
  g_assert(base != 0);

  if(base->insert_at_cursor)
    (*base->insert_at_cursor)(gobj(),str.c_str());
}

void Gtk::Entry::on_delete_from_cursor(DeleteType type, int count)
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class.
);
  g_assert(base != 0);

  if(base->delete_from_cursor)
    (*base->delete_from_cursor)(gobj(),((GtkDeleteType)(type)),count);
}

void Gtk::Entry::on_cut_clipboard()
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class.
);
  g_assert(base != 0);

  if(base->cut_clipboard)
    (*base->cut_clipboard)(gobj());
}

void Gtk::Entry::on_copy_clipboard()
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class.
);
  g_assert(base != 0);

  if(base->copy_clipboard)
    (*base->copy_clipboard)(gobj());
}

void Gtk::Entry::on_paste_clipboard()
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class.
);
  g_assert(base != 0);

  if(base->paste_clipboard)
    (*base->paste_clipboard)(gobj());
}

void Gtk::Entry::on_toggle_overwrite()
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class.
);
  g_assert(base != 0);

  if(base->toggle_overwrite)
    (*base->toggle_overwrite)(gobj());
}


} // namespace Gtk

