// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_FILESELECTION_H
#define _GTKMM_FILESELECTION_H

#include <glibmm.h>

/* $Id: fileselection.hg,v 1.21 2002/04/01 16:19:34 murrayc Exp $ */


/* fileselection.h
 * 
 * Copyright (C) 1998-1999 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/dialog.h>
#include <gtkmm/button.h>
#include <gtkmm/entry.h>
#include <gtkmm/label.h>
#include <gtkmm/box.h>
#include <gtkmm/treeview.h>
#include <gtkmm/buttonbox.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkFileSelection GtkFileSelection;
typedef struct _GtkFileSelectionClass GtkFileSelectionClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gtk
{ class FileSelection_Class; } // namespace Gtk
namespace Gtk
{

/** @ingroup Dialogs
 */

class FileSelection : public Dialog
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef FileSelection CppObjectType;
  typedef FileSelection_Class CppClassType;
  typedef GtkFileSelection BaseObjectType;
  typedef GtkFileSelectionClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~FileSelection();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class CppClassType;
  static CppClassType fileselection_class_;

  FileSelection(const FileSelection&);
  FileSelection& operator=(const FileSelection&); // not implemented

protected:
  explicit FileSelection(GtkFileSelection* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkFileSelection* gobj()             { return (GtkFileSelection*)(gobject_); }
  const GtkFileSelection* gobj() const { return (GtkFileSelection*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

public:
	
  FileSelection();
  explicit FileSelection(const Glib::ustring& title);
  

  void set_filename(const Glib::ustring& filename);
  
  /** This function returns the selected filename in encoding of
   * g_filename_from_utf8(), which may or may not be the same as that
   * used by GTK+ (UTF-8). To convert to UTF-8, call g_filename_to_utf8().
   * The returned string points to a statically allocated buffer and
   * should be copied if you plan to keep it around.
   * @return Currently-selected filename in locale's encoding.
   */
  Glib::ustring get_filename() const;

  
  void complete(const Glib::ustring& pattern);
  
  void show_fileop_buttons();
  
  void hide_fileop_buttons();
  //gchar**    gtk_file_selection_get_selections      (GtkFileSelection *filesel);
  
  /** Sets whether the user is allowed to select multiple files in the file list.
   * Use get_selections() to get the list of selected files.
   * @param select_multiple Whether or not the user is allowed to select multiple
   * files in the file list.
   */
  void set_select_multiple(bool elect_multiple = true);
  
  /** Determines whether or not the user is allowed to select multiple files in
   * the file list. See set_select_multiple().
   * @return <tt>true</tt> if the user is allowed to select multiple files in the
   * file list.
   */
  bool get_select_multiple() const;

  //: Accessors
  TreeView* get_dir_list();
  const TreeView* get_dir_list() const;
  TreeView* get_file_list();
  const TreeView* get_file_list() const;
  Entry* get_selection_entry();
  const Entry* get_selection_entry() const;
  Label* get_selection_text();
  const Label* get_selection_text() const;
  VBox* get_main_vbox();
  const VBox* get_main_vbox() const;
  Button* get_ok_button();
  const Button* get_ok_button() const;
  Button* get_cancel_button();
  const Button* get_cancel_button() const;
  Button* get_help_button();
  const Button* get_help_button() const;
  HButtonBox* get_button_area();
  const HButtonBox* get_button_area() const;
  HBox* get_action_area();
  const HBox* get_action_area() const;

  Glib::PropertyProxy<bool> property_show_fileops();

  Glib::PropertyProxy<Glib::ustring> property_filename();

  Glib::PropertyProxy<bool> property_select_multiple();


};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::FileSelection */
  Gtk::FileSelection* wrap(GtkFileSelection* object, bool take_copy = false);
}
#endif /* _GTKMM_FILESELECTION_H */

