// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_LISTSTORE_H
#define _GTKMM_LISTSTORE_H

#include <glibmm.h>

/* $Id: liststore.hg,v 1.12 2002/04/02 13:25:18 daniel Exp $ */

/* liststore.h
 *
 * Copyright(C) 1998-1999 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or(at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <glibmm/object.h>
#include <gtkmm/treeiter.h>
#include <gtkmm/treemodel.h>
#include <gtkmm/treesortable.h>
#include <gtkmm/treedragdest.h>
#include <gtkmm/treedragsource.h>
#include <glibmm/arrayhandle.h>
#include <glibmm/value.h>
#include <gtk/gtkliststore.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
//typedef struct _GtkListStore GtkListStore;
//typedef struct _GtkListStoreClass GtkListStoreClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gtk
{ class ListStore_Class; } // namespace Gtk
namespace Gtk
{

/** Thist is a list model for use with a Gtk::TreeView widget.
 * It implements the Gtk::TreeModel interface, and also implements the Gtk::TreeSortable interface so you can sort the list using the view.
 * Finally, it also implements the tree drag and drop interfaces.
 *
 * @ingroup TreeView
*/

class ListStore
 : public Glib::Object,
   public TreeModel,
   public TreeSortable,
   public TreeDragSource,
   public TreeDragDest
{
   public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef ListStore          CppObjectType;
  typedef ListStore_Class    CppClassType;
  typedef GtkListStore           BaseObjectType;
  typedef GtkListStoreClass      BaseClassType;

private:
  friend class CppClassType;
  static CppClassType liststore_class_;

  ListStore(const ListStore&);
  ListStore& operator=(const ListStore&); // not implemented

protected:
  explicit ListStore(GtkListStore* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~ListStore();

  static Glib::RefPtr<ListStore> wrap_specific_type(GtkListStore* gobject, bool take_copy = false); //Re-uses the existing wrapper, if it exists.

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkListStore* gobj()             { return (GtkListStore*)(gobject_); }
  const GtkListStore* gobj() const { return (GtkListStore*)(gobject_); }

  GtkListStore* gobj_copy();


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

   
protected:
  explicit ListStore(const TreeModelColumnRecord& columns);

public:
  
  static Glib::RefPtr<ListStore> create(const TreeModelColumnRecord& columns);


  TreeIter erase(const TreeIter& iter);
  TreeIter insert(const TreeIter& iter);
  TreeIter prepend();
  TreeIter append();

  template <class ColumnType>
  void set_value(const TreeIter& row, const ColumnType& column,
                 const typename ColumnType::ElementType& data);

  
  /** Removes all rows from the list store.
   */
  void clear();

protected:
  
  /** Sets the data in the cell specified by @a iter and @a column.
   * The type of @a value must be convertible to the type of the
   * column.
   * @param iter A valid Gtk::TreeIter for the row being modified.
   * @param column Column number to modify.
   * @param value New value for the cell.
   */
  void set_value_impl(const TreeIter& row, int column, const Glib::ValueBase& value);


};


template <class ColumnType>
void ListStore::set_value(const TreeIter& row, const ColumnType& column,
                          const typename ColumnType::ElementType& data)
{
  typename ColumnType::ValueType value;
  value.init(column.type());

  value.set(data);
  set_value_impl(row, column.index(), value);
}

} // namespace Gtk


namespace Glib
{
  /** @relates Gtk::ListStore */
  Glib::RefPtr<Gtk::ListStore> wrap(GtkListStore* object, bool take_copy = false);
}


#endif /* _GTKMM_LISTSTORE_H */

