// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_STYLE_H
#define _GTKMM_STYLE_H

#include <glibmm.h>

/* $Id: style.hg,v 1.26 2002/04/09 20:53:26 murrayc Exp $ */

/* style.gen_h
 * 
 * Copyright (C) 1998-1999 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk/gtkstyle.h>


#include <pangomm/fontdescription.h>
#include <gdkmm/gc.h>
#include <gdkmm/pixmap.h>
#include <gdkmm/types.h>
#include <gdkmm/window.h>

#include <gtkmm/object.h>
#include <gtkmm/enums.h>
#include <gtkmmconfig.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
//typedef struct _GtkStyle GtkStyle;
//typedef struct _GtkStyleClass GtkStyleClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gtk
{ class Style_Class; } // namespace Gtk
namespace Gtk
{

class RC;
class RCStyle;
class Widget;
class Style;

// TODO:
// This wrapper is very temporary.  There should be a new
// replacement for this at some point when gtk+ adds a data 
// field.  For now only setting the colors works.  When
// gtk+ gets field, all draw_* become virtual and one can define
// their own style in C++.

class Style : public Glib::Object
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Style          CppObjectType;
  typedef Style_Class    CppClassType;
  typedef GtkStyle           BaseObjectType;
  typedef GtkStyleClass      BaseClassType;

private:
  friend class CppClassType;
  static CppClassType style_class_;

  Style(const Style&);
  Style& operator=(const Style&); // not implemented

protected:
  explicit Style(GtkStyle* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Style();

  static Glib::RefPtr<Style> wrap_specific_type(GtkStyle* gobject, bool take_copy = false); //Re-uses the existing wrapper, if it exists.

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkStyle* gobj()             { return (GtkStyle*)(gobject_); }
  const GtkStyle* gobj() const { return (GtkStyle*)(gobject_); }

  GtkStyle* gobj_copy();


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:


  friend class RC;
  friend class RCStyle;
  friend class Widget;
 
public:
   

  // These are worthless to the users they should use set_style instead.
  //Gtk::Style* attach(const Glib::RefPtr<Gdk::Window> &window);
  //void       detach();


/* These can only be called pior to the first use */  
  void set_background(const Glib::RefPtr<const Gdk::Window>& window, StateType state_type);
  void apply_default_background(const Glib::RefPtr<const Gdk::Window> &window,
				bool set_bg,
				StateType state_type,
				const Gdk::Rectangle &area,
				int          x, 
				int          y, 
				int          width, 
				int          height);

  void set_bg    ( StateType state_type, const Gdk::Color &new_color );
  void set_light ( StateType state_type, const Gdk::Color &new_color );
  void set_dark  ( StateType state_type, const Gdk::Color &new_color );
  void set_mid   ( StateType state_type, const Gdk::Color &new_color );
  void set_base  ( StateType state_type, const Gdk::Color &new_color );
  void set_fg    ( StateType state_type, const Gdk::Color &new_color );
  void set_text  ( StateType state_type, const Gdk::Color &new_color );

  void set_font(const Pango::FontDescription& font_desc);

/* These are only available after being attached to a window */
  Pango::FontDescription get_font() const;

  //TODO: need const versions of these too, like the ones that _MEMBER_GET_GOBJECT() would generate.
  Glib::RefPtr<Gdk::GC> get_fg_gc  ( StateType state_type);
  Glib::RefPtr<Gdk::GC> get_bg_gc  ( StateType state_type);
  Glib::RefPtr<Gdk::GC> get_light_gc( StateType state_type);
  Glib::RefPtr<Gdk::GC> get_dark_gc( StateType state_type);
  Glib::RefPtr<Gdk::GC> get_mid_gc ( StateType state_type);
  Glib::RefPtr<Gdk::GC> get_text_gc( StateType state_type);
  Glib::RefPtr<Gdk::GC> get_base_gc( StateType state_type);

  Glib::RefPtr<Gdk::GC> get_black_gc();
  Glib::RefPtr<const Gdk::GC> get_black_gc() const;
  Glib::RefPtr<Gdk::GC> get_white_gc();
  Glib::RefPtr<const Gdk::GC> get_white_gc() const;

  Gdk::Color Style::get_background(StateType state_type) const;
  Glib::RefPtr<Gdk::Pixmap> get_background_pixmap(StateType state_type);

/* Drawing functions */
/* deprecated:
  void draw_hline               (const Glib::RefPtr<Gdk::Window>     &window,
				 StateType   state_type,
				 int           x1,
				 int           x2,
				 int           y) const;

  void draw_vline               (const Glib::RefPtr<Gdk::Window>     &window,
				 StateType   state_type,
				 int           y1,
				 int           y2,
				 int           x) const;

  void draw_shadow              (const Glib::RefPtr<Gdk::Window>     &window,
				 StateType   state_type,
				 ShadowType  shadow_type,
				 int           x,
				 int           y,
				 int           width,
				 int           height) const;

  void draw_polygon             (const Glib::RefPtr<Gdk::Window>     &window,
				 StateType   state_type,
				 ShadowType  shadow_type,
				 GdkPoint      *points,
				 int           npoints,
				 int           fill) const;

  void draw_arrow               (const Glib::RefPtr<Gdk::Window>     &window,
				 StateType   state_type,
				 ShadowType  shadow_type,
				 ArrowType   arrow_type,
				 int           fill,
				 int           x,
				 int           y,
				 int           width,
				 int           height) const;

  void draw_diamond             (const Glib::RefPtr<Gdk::Window>     &window,
				 StateType   state_type,
				 ShadowType  shadow_type,
				 int           x,
				 int           y,
				 int           width,
				 int           height) const;

  void draw_string              (const Glib::RefPtr<Gdk::Window>     &window,
				 StateType   state_type,
				 int           x,
				 int           y,
				 const Glib::ustring& string) const;
*/


};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::Style */
  Glib::RefPtr<Gtk::Style> wrap(GtkStyle* object, bool take_copy = false);
}


#endif /* _GTKMM_STYLE_H */

