
#include <gtkmm/texttag.h>
#include <gtkmm/private/texttag_p.h>

// -*- c++ -*-
/* $Id: texttag.ccg,v 1.4 2001/11/13 00:41:43 murrayc Exp $ */

/* 
 *
 * Copyright 1998-1999 The Gtk-- Development Team
 * Copyright 2001      Free Software Foundation
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/textiter.h>

namespace
{


gboolean TextTag_signal_event_callback(GtkTextTag*, GObject* p0,GdkEvent* p1,const GtkTextIter* p2,void* data)
{
  using namespace Gtk;
  typedef SigC::Slot3<bool,const Glib::RefPtr<Glib::Object>&,GdkEvent*,const TextIter&> SlotType;

  try
  {
    SigC::SlotNode *const slot = Glib::SignalProxyNormal::data_to_slot(data);
    return static_cast<int>(((*(SlotType::Proxy)(slot->proxy_))
        (Glib::wrap(p0, true)
,p1,Glib::wrap(p2)
, slot)));
  }
  catch(...)
  {
    Glib::exception_handlers_invoke();
  }

  typedef gboolean RType;
  return RType();
}

gboolean TextTag_signal_event_notify_callback(GtkTextTag*, GObject* p0,GdkEvent* p1,const GtkTextIter* p2,void* data)
{
  using namespace Gtk;
  typedef SigC::Slot3<void,const Glib::RefPtr<Glib::Object>&,GdkEvent*,const TextIter&> SlotType;

  try
  {
    SigC::SlotNode *const slot = Glib::SignalProxyNormal::data_to_slot(data);
    (*(SlotType::Proxy)(slot->proxy_))
        (Glib::wrap(p0, true)
,p1,Glib::wrap(p2)
, slot);
  }
  catch(...)
  {
    Glib::exception_handlers_invoke();
  }

  typedef gboolean RType;
  return RType();
}


const Glib::SignalProxyInfo TextTag_signal_event_info =
{
  "event",
  (GCallback) &TextTag_signal_event_callback,
  (GCallback) &TextTag_signal_event_notify_callback
};

} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Gtk::TextTag> wrap(GtkTextTag* object, bool take_copy /* = false */)
{
  return Glib::RefPtr<Gtk::TextTag>( dynamic_cast<Gtk::TextTag*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Gtk
{


/* The *_Class implementation: */

GType TextTag_Class::get_type()
  {
    if (!gtype_) //Create the GType if necessary.
      {
        //Make sure that the parent type has been created:
        CppClassParent::CppObjectType::get_type();

        //Create a derived C type.
        //These init funcs will, in turn, call the init functions in the base C type.
        GTypeInfo info =
          {
            sizeof(BaseClassType), /* class_size */
            0, /* base_init */
            0, /* base_finalize */
            (GClassInitFunc) &class_init_function, /* class_init */
            0, /* class_finalize */
            0, /* class_data */
            sizeof(BaseObjectType), /* instance_size */
            0, /* n_preallocs */
            0, /* instance_init */
	    0 /* value_table */
          };

        gtype_ = g_type_register_static(gtk_text_tag_get_type(), "gtkmm__TextTag", &info, GTypeFlags(0));

  //Add derived versions of interfaces, if the C type implements any interfaces:
      }
    return gtype_;
  }
void TextTag_Class::class_init_function(BaseClassType* klass)
{
  CppClassParent::class_init_function((CppClassParent::BaseClassType*) klass);
  klass->event = &event_callback;
}


gboolean TextTag_Class::event_callback(GtkTextTag* self, GObject* p0, GdkEvent* p1, const GtkTextIter* p2)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  if(obj)
  {
    try
    {
      return static_cast<int>(obj->on_event(Glib::wrap(p0, true)
, p1, Glib::wrap(p2)
));
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class.
);
    g_assert(base != 0);

    if(base->event)
      (*base->event)(self, p0, p1, p2);
  }

  typedef gboolean RType;
  return RType();
}


Glib::ObjectBase* TextTag_Class::wrap_new(GObject* o)
{
  return new TextTag((GtkTextTag*)(o));
}


/* The implementation: */

GtkTextTag* TextTag::gobj_copy()
{
  reference();
  return gobj();
}

Glib::RefPtr<TextTag> TextTag::wrap_specific_type(GtkTextTag* gobject, bool take_copy /* = false */) //static
{
  Glib::RefPtr<TextTag> refPtr;

  if(gobject)
  {
    //Check for an existing wrapper:
    TextTag* pCppObject = dynamic_cast<TextTag*>(Glib::ObjectBase::_get_current_wrapper(G_OBJECT(gobject)));
    if(pCppObject)
    {
      //Return the existing wrapper:
      refPtr = Glib::RefPtr<TextTag>(pCppObject);
    }
    else
    {
      //Create a new wrapper:
      refPtr = Glib::RefPtr<TextTag>( new TextTag(gobject) );
    }

    if(take_copy && refPtr)
      refPtr->reference();
  }

  return refPtr;
}

TextTag::TextTag(GtkTextTag* castitem)
: Glib::Object((GObject*)(castitem))
{}

TextTag::~TextTag()
{
}

TextTag::CppClassType TextTag::texttag_class_; //Initialize static member.

GType TextTag::get_type()
{
  return texttag_class_.get_type();
}

GType TextTag::get_base_type()
{
  return gtk_text_tag_get_type();
}

TextTag::TextTag()
: Glib::Object((GObject*)(g_object_new(get_type(), (char*)0)))
{}

TextTag::TextTag(const Glib::ustring& name)
: Glib::Object((GObject*)( g_object_new(get_type(), "name", name.c_str(), (char*)0) ))
{}

Glib::RefPtr<TextTag> TextTag::create()
{
  return Glib::RefPtr<TextTag>( new TextTag() );
}
Glib::RefPtr<TextTag> TextTag::create(const Glib::ustring& name)
{
  return Glib::RefPtr<TextTag>( new TextTag(name) );
}
int TextTag::get_priority() const
{
  return gtk_text_tag_get_priority(const_cast<GtkTextTag*>(gobj()));
}

void TextTag::set_priority(int priority)
{
  gtk_text_tag_set_priority(gobj(), priority);
}

bool TextTag::event(const Glib::RefPtr<Glib::Object>& event_object, GdkEvent* event, const TextIter& iter)
{
  return gtk_text_tag_event(gobj(), Glib::unwrap(event_object), event, (iter).gobj());
}


Glib::SignalProxy3<bool,const Glib::RefPtr<Glib::Object>&,GdkEvent*,const TextIter&> TextTag::signal_event()
{
  return Glib::SignalProxy3<bool,const Glib::RefPtr<Glib::Object>&,GdkEvent*,const TextIter&>(this, &TextTag_signal_event_info);
}


Glib::PropertyProxy_WriteOnly<Glib::ustring> TextTag::property_background()
{
  return Glib::PropertyProxy_WriteOnly<Glib::ustring>(this, "background");
}

Glib::PropertyProxy_WriteOnly<Glib::ustring> TextTag::property_foreground()
{
  return Glib::PropertyProxy_WriteOnly<Glib::ustring>(this, "foreground");
}

Glib::PropertyProxy<Gdk::Color> TextTag::property_background_gdk()
{
  return Glib::PropertyProxy<Gdk::Color>(this, "background_gdk");
}

Glib::PropertyProxy<Gdk::Color> TextTag::property_foreground_gdk()
{
  return Glib::PropertyProxy<Gdk::Color>(this, "foreground_gdk");
}

Glib::PropertyProxy< Glib::RefPtr<Gdk::Bitmap> > TextTag::property_background_stipple()
{
  return Glib::PropertyProxy< Glib::RefPtr<Gdk::Bitmap> >(this, "background_stipple");
}

Glib::PropertyProxy< Glib::RefPtr<Gdk::Bitmap> > TextTag::property_foreground_stipple()
{
  return Glib::PropertyProxy< Glib::RefPtr<Gdk::Bitmap> >(this, "foreground_stipple");
}

Glib::PropertyProxy<Glib::ustring> TextTag::property_font()
{
  return Glib::PropertyProxy<Glib::ustring>(this, "font");
}

Glib::PropertyProxy<Pango::FontDescription> TextTag::property_font_desc()
{
  return Glib::PropertyProxy<Pango::FontDescription>(this, "font_desc");
}

Glib::PropertyProxy<Glib::ustring> TextTag::property_family()
{
  return Glib::PropertyProxy<Glib::ustring>(this, "family");
}

Glib::PropertyProxy<Pango::Style> TextTag::property_style()
{
  return Glib::PropertyProxy<Pango::Style>(this, "style");
}

Glib::PropertyProxy<Pango::Variant> TextTag::property_variant()
{
  return Glib::PropertyProxy<Pango::Variant>(this, "variant");
}

Glib::PropertyProxy<int> TextTag::property_weight()
{
  return Glib::PropertyProxy<int>(this, "weight");
}

Glib::PropertyProxy<Pango::Stretch> TextTag::property_stretch()
{
  return Glib::PropertyProxy<Pango::Stretch>(this, "stretch");
}

Glib::PropertyProxy<int> TextTag::property_size()
{
  return Glib::PropertyProxy<int>(this, "size");
}

Glib::PropertyProxy<double> TextTag::property_size_points()
{
  return Glib::PropertyProxy<double>(this, "size_points");
}

Glib::PropertyProxy<double> TextTag::property_scale()
{
  return Glib::PropertyProxy<double>(this, "scale");
}

Glib::PropertyProxy<int> TextTag::property_pixels_above_lines()
{
  return Glib::PropertyProxy<int>(this, "pixels_above_lines");
}

Glib::PropertyProxy<int> TextTag::property_pixels_below_lines()
{
  return Glib::PropertyProxy<int>(this, "pixels_below_lines");
}

Glib::PropertyProxy<int> TextTag::property_pixels_inside_wrap()
{
  return Glib::PropertyProxy<int>(this, "pixels_inside_wrap");
}

Glib::PropertyProxy<bool> TextTag::property_editable()
{
  return Glib::PropertyProxy<bool>(this, "editable");
}

Glib::PropertyProxy<WrapMode> TextTag::property_wrap_mode()
{
  return Glib::PropertyProxy<WrapMode>(this, "wrap_mode");
}

Glib::PropertyProxy<Justification> TextTag::property_justification()
{
  return Glib::PropertyProxy<Justification>(this, "justification");
}

Glib::PropertyProxy<TextDirection> TextTag::property_direction()
{
  return Glib::PropertyProxy<TextDirection>(this, "direction");
}

Glib::PropertyProxy<int> TextTag::property_left_margin()
{
  return Glib::PropertyProxy<int>(this, "left_margin");
}

Glib::PropertyProxy<int> TextTag::property_indent()
{
  return Glib::PropertyProxy<int>(this, "indent");
}

Glib::PropertyProxy<bool> TextTag::property_strikethrough()
{
  return Glib::PropertyProxy<bool>(this, "strikethrough");
}

Glib::PropertyProxy<int> TextTag::property_right_margin()
{
  return Glib::PropertyProxy<int>(this, "right_margin");
}

Glib::PropertyProxy<Pango::Underline> TextTag::property_underline()
{
  return Glib::PropertyProxy<Pango::Underline>(this, "underline");
}

Glib::PropertyProxy<int> TextTag::property_rise()
{
  return Glib::PropertyProxy<int>(this, "rise");
}

Glib::PropertyProxy<bool> TextTag::property_background_full_height()
{
  return Glib::PropertyProxy<bool>(this, "background_full_height");
}

Glib::PropertyProxy<Glib::ustring> TextTag::property_language()
{
  return Glib::PropertyProxy<Glib::ustring>(this, "language");
}

Glib::PropertyProxy<Pango::TabArray> TextTag::property_tabs()
{
  return Glib::PropertyProxy<Pango::TabArray>(this, "tabs");
}

Glib::PropertyProxy<bool> TextTag::property_invisible()
{
  return Glib::PropertyProxy<bool>(this, "invisible");
}

Glib::PropertyProxy<bool> TextTag::property_background_set()
{
  return Glib::PropertyProxy<bool>(this, "background_set");
}

Glib::PropertyProxy<bool> TextTag::property_foreground_set()
{
  return Glib::PropertyProxy<bool>(this, "foreground_set");
}

Glib::PropertyProxy<bool> TextTag::property_background_stipple_set()
{
  return Glib::PropertyProxy<bool>(this, "background_stipple_set");
}

Glib::PropertyProxy<bool> TextTag::property_foreground_stipple_set()
{
  return Glib::PropertyProxy<bool>(this, "foreground_stipple_set");
}

Glib::PropertyProxy<bool> TextTag::property_family_set()
{
  return Glib::PropertyProxy<bool>(this, "family_set");
}

Glib::PropertyProxy<bool> TextTag::property_style_set()
{
  return Glib::PropertyProxy<bool>(this, "style_set");
}

Glib::PropertyProxy<bool> TextTag::property_variant_set()
{
  return Glib::PropertyProxy<bool>(this, "variant_set");
}

Glib::PropertyProxy<bool> TextTag::property_weight_set()
{
  return Glib::PropertyProxy<bool>(this, "weight_set");
}

Glib::PropertyProxy<bool> TextTag::property_stretch_set()
{
  return Glib::PropertyProxy<bool>(this, "stretch_set");
}

Glib::PropertyProxy<bool> TextTag::property_size_set()
{
  return Glib::PropertyProxy<bool>(this, "size_set");
}

Glib::PropertyProxy<bool> TextTag::property_scale_set()
{
  return Glib::PropertyProxy<bool>(this, "scale_set");
}

Glib::PropertyProxy<bool> TextTag::property_pixels_above_lines_set()
{
  return Glib::PropertyProxy<bool>(this, "pixels_above_lines_set");
}

Glib::PropertyProxy<bool> TextTag::property_pixels_below_lines_set()
{
  return Glib::PropertyProxy<bool>(this, "pixels_below_lines_set");
}

Glib::PropertyProxy<bool> TextTag::property_pixels_inside_wrap_set()
{
  return Glib::PropertyProxy<bool>(this, "pixels_inside_wrap_set");
}

Glib::PropertyProxy<bool> TextTag::property_editable_set()
{
  return Glib::PropertyProxy<bool>(this, "editable_set");
}

Glib::PropertyProxy<bool> TextTag::property_wrap_mode_set()
{
  return Glib::PropertyProxy<bool>(this, "wrap_mode_set");
}

Glib::PropertyProxy<bool> TextTag::property_justification_set()
{
  return Glib::PropertyProxy<bool>(this, "justification_set");
}

Glib::PropertyProxy<bool> TextTag::property_left_margin_set()
{
  return Glib::PropertyProxy<bool>(this, "left_margin_set");
}

Glib::PropertyProxy<bool> TextTag::property_indent_set()
{
  return Glib::PropertyProxy<bool>(this, "indent_set");
}

Glib::PropertyProxy<bool> TextTag::property_strikethrough_set()
{
  return Glib::PropertyProxy<bool>(this, "strikethrough_set");
}

Glib::PropertyProxy<bool> TextTag::property_right_margin_set()
{
  return Glib::PropertyProxy<bool>(this, "right_margin_set");
}

Glib::PropertyProxy<bool> TextTag::property_underline_set()
{
  return Glib::PropertyProxy<bool>(this, "underline_set");
}

Glib::PropertyProxy<bool> TextTag::property_rise_set()
{
  return Glib::PropertyProxy<bool>(this, "rise_set");
}

Glib::PropertyProxy<bool> TextTag::property_background_full_height_set()
{
  return Glib::PropertyProxy<bool>(this, "background_full_height_set");
}

Glib::PropertyProxy<bool> TextTag::property_language_set()
{
  return Glib::PropertyProxy<bool>(this, "language_set");
}

Glib::PropertyProxy<bool> TextTag::property_tabs_set()
{
  return Glib::PropertyProxy<bool>(this, "tabs_set");
}

Glib::PropertyProxy<bool> TextTag::property_invisible_set()
{
  return Glib::PropertyProxy<bool>(this, "invisible_set");
}


bool Gtk::TextTag::on_event(const Glib::RefPtr<Glib::Object>& event_object, GdkEvent* event, const TextIter& iter)
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class.
);
  g_assert(base != 0);

  if(base->event)
    return (*base->event)(gobj(),Glib::unwrap(event_object),event,(iter).gobj());

  typedef bool RType;
  return RType();
}


} // namespace Gtk

