// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_VIEWPORT_H
#define _GTKMM_VIEWPORT_H

#include <glibmm.h>

/* $Id: viewport.hg,v 1.19 2002/04/02 13:25:20 daniel Exp $ */

/* viewport.h
 * 
 * Copyright (C) 1998-1999 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/bin.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkViewport GtkViewport;
typedef struct _GtkViewportClass GtkViewportClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gtk
{ class Viewport_Class; } // namespace Gtk
namespace Gtk {
class Adjustment;

/**
 * @ingroup Widgets
 * @ingroup Containers
 */

class Viewport : public Bin
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Viewport CppObjectType;
  typedef Viewport_Class CppClassType;
  typedef GtkViewport BaseObjectType;
  typedef GtkViewportClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Viewport();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class CppClassType;
  static CppClassType viewport_class_;

  Viewport(const Viewport&);
  Viewport& operator=(const Viewport&); // not implemented

protected:
  explicit Viewport(GtkViewport* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkViewport* gobj()             { return (GtkViewport*)(gobject_); }
  const GtkViewport* gobj() const { return (GtkViewport*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_set_scroll_adjustments(Gtk::Adjustment* hadjustment, Gtk::Adjustment* vadjustment);


private:

public:

  explicit Viewport(Adjustment& hadjustment, Adjustment& vadjustment);


  /** Returns the horizontal adjustment of the viewport.
   * @return The horizontal adjustment of @a viewport.
   */
  Gtk::Adjustment* get_hadjustment();
  
  /** Returns the horizontal adjustment of the viewport.
   * @return The horizontal adjustment of @a viewport.
   */
  const Gtk::Adjustment* get_hadjustment() const;

  
  /** Returns the vertical adjustment of the viewport.
   * @return The vertical adjustment of @a viewport.
   */
  Gtk::Adjustment* get_vadjustment();
  
  /** Returns the vertical adjustment of the viewport.
   * @return The vertical adjustment of @a viewport.
   */
  const Gtk::Adjustment* get_vadjustment() const;

  
  /** Sets the horizontal adjustment of the viewport.
   * @param adjustment A Gtk::Adjustment.
   */
  void set_hadjustment(Gtk::Adjustment* adjustment=0);
  
  /** Sets the horizontal adjustment of the viewport.
   * @param adjustment A Gtk::Adjustment.
   */
  void set_hadjustment(Gtk::Adjustment& adjustment);

  
  /** Sets the vertical adjustment of the viewport.
   * @param adjustment A Gtk::Adjustment.
   */
  void set_vadjustment(Gtk::Adjustment* adjustment=0);
  
  /** Sets the vertical adjustment of the viewport.
   * @param adjustment A Gtk::Adjustment.
   */
  void set_vadjustment(Gtk::Adjustment& adjustment);

  
  /** Sets the shadow type of the viewport.
   * @param type The new shadow type.
   */
  void set_shadow_type(ShadowType type);

  
  /** Gets the shadow type of the Gtk::Viewport. See
   * set_shadow_type().
   * @return The shadow type.
   */
  ShadowType get_shadow_type() const;

  
  /**
   * @par Prototype:
   * <tt>void %set_scroll_adjustments(Gtk::Adjustment* hadjustment, Gtk::Adjustment* vadjustment)</tt>
   */
  Glib::SignalProxy2<void,Gtk::Adjustment*,Gtk::Adjustment*> signal_set_scroll_adjustments();


  Glib::PropertyProxy<Gtk::Adjustment*> property_hadjustment();

  Glib::PropertyProxy<Gtk::Adjustment*> property_vadjustment();

  Glib::PropertyProxy<ShadowType> property_shadow_type();


};

}  /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::Viewport */
  Gtk::Viewport* wrap(GtkViewport* object, bool take_copy = false);
}
#endif /* _GTKMM_VIEWPORT_H */

